package bt.spp.printing;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "bt.spp.printing", "bt.spp.printing.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "bt.spp.printing", "bt.spp.printing.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "bt.spp.printing.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        Object[] o;
        if (permissions.length > 0)
            o = new Object[] {permissions[0], grantResults[0] == 0};
        else
            o = new Object[] {"", false};
        processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        b4a.example.dateutils._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public static String _printbuffer = "";
public static anywheresoftware.b4a.objects.Serial.BluetoothAdmin _btadmin = null;
public static anywheresoftware.b4a.objects.Serial _cmp20 = null;
public static anywheresoftware.b4a.objects.streams.File.TextWriterWrapper _printer = null;
public static String _anormal = "";
public static String _abold = "";
public static String _adoublewide = "";
public static String _adoublehigh = "";
public static String _adoublewidehigh = "";
public static String _aunderline = "";
public static String _bnormal = "";
public static String _bbold = "";
public static String _bdoublewide = "";
public static String _bdoublehigh = "";
public static String _bdoublewidehigh = "";
public static String _bunderline = "";
public smm.datecswrapperp.datecswrapper _printer2 = null;
public anywheresoftware.b4a.randomaccessfile.AsyncStreams _astream = null;
public b4a.example.dateutils _dateutils = null;
public static String  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create"))
	return (String) Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime});
RDebugUtils.currentLine=131072;
 //BA.debugLineNum = 131072;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="aNormal = Chr(27) & \"!\" & Chr(0)";
_anormal = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (0)));
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="aBold = Chr(27) & \"!\" & Chr(8)";
_abold = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (8)));
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="aDoubleHigh = Chr(27) & \"!\" & Chr(16)";
_adoublehigh = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (16)));
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="aDoubleWide = Chr(27) & \"!\" & Chr(32)";
_adoublewide = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (32)));
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="aDoubleWideHigh = Chr(27) & \"!\" & Chr(48)";
_adoublewidehigh = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (48)));
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="bNormal = Chr(27) & \"!\" & Chr(1)";
_bnormal = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (1)));
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="bBold = Chr(27) & \"!\" & Chr(9)";
_bbold = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (9)));
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="bDoubleHigh = Chr(27) & \"!\" & Chr(17)";
_bdoublehigh = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (17)));
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="bDoubleWide = Chr(27) & \"!\" & Chr(33)";
_bdoublewide = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (33)));
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="bDoubleWideHigh = Chr(27) & \"!\" & Chr(49)";
_bdoublewidehigh = BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (27)))+"!"+BA.ObjectToString(anywheresoftware.b4a.keywords.Common.Chr((int) (49)));
RDebugUtils.currentLine=131085;
 //BA.debugLineNum = 131085;BA.debugLine="If FirstTime Then";
if (_firsttime) { 
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="btAdmin.Initialize(\"BlueTeeth\")";
_btadmin.Initialize(processBA,"BlueTeeth");
RDebugUtils.currentLine=131087;
 //BA.debugLineNum = 131087;BA.debugLine="cmp20.Initialize(\"Printer\")";
_cmp20.Initialize("Printer");
 };
RDebugUtils.currentLine=131089;
 //BA.debugLineNum = 131089;BA.debugLine="StartPrinter";
_startprinter();
RDebugUtils.currentLine=131090;
 //BA.debugLineNum = 131090;BA.debugLine="End Sub";
return "";
}
public static String  _startprinter() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "startprinter"))
	return (String) Debug.delegate(mostCurrent.activityBA, "startprinter", null);
anywheresoftware.b4a.objects.collections.Map _paireddevices = null;
anywheresoftware.b4a.objects.collections.List _l = null;
int _res = 0;
int _i = 0;
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub StartPrinter";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="Dim PairedDevices As Map";
_paireddevices = new anywheresoftware.b4a.objects.collections.Map();
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="Dim L As List";
_l = new anywheresoftware.b4a.objects.collections.List();
RDebugUtils.currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="Dim Res As Int";
_res = 0;
RDebugUtils.currentLine=393221;
 //BA.debugLineNum = 393221;BA.debugLine="ToastMessageShow(\"Printing.....\",True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Printing.....",anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=393223;
 //BA.debugLineNum = 393223;BA.debugLine="PairedDevices.Initialize";
_paireddevices.Initialize();
RDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="Try";
try {RDebugUtils.currentLine=393226;
 //BA.debugLineNum = 393226;BA.debugLine="PairedDevices = cmp20.GetPairedDevices";
_paireddevices = _cmp20.GetPairedDevices();
 } 
       catch (Exception e9) {
			processBA.setLastException(e9);RDebugUtils.currentLine=393228;
 //BA.debugLineNum = 393228;BA.debugLine="Msgbox(\"Getting Paired Devices\",\"Printer Error\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Getting Paired Devices","Printer Error",mostCurrent.activityBA);
RDebugUtils.currentLine=393229;
 //BA.debugLineNum = 393229;BA.debugLine="printer.Close";
_printer.Close();
RDebugUtils.currentLine=393230;
 //BA.debugLineNum = 393230;BA.debugLine="cmp20.Disconnect";
_cmp20.Disconnect();
 };
RDebugUtils.currentLine=393233;
 //BA.debugLineNum = 393233;BA.debugLine="If PairedDevices.Size = 0 Then";
if (_paireddevices.getSize()==0) { 
RDebugUtils.currentLine=393234;
 //BA.debugLineNum = 393234;BA.debugLine="Msgbox(\"Error Connecting to Printer - Printer No";
anywheresoftware.b4a.keywords.Common.Msgbox("Error Connecting to Printer - Printer Not Found","",mostCurrent.activityBA);
RDebugUtils.currentLine=393235;
 //BA.debugLineNum = 393235;BA.debugLine="Return";
if (true) return "";
 };
RDebugUtils.currentLine=393238;
 //BA.debugLineNum = 393238;BA.debugLine="If PairedDevices.Size = 1 Then";
if (_paireddevices.getSize()==1) { 
RDebugUtils.currentLine=393239;
 //BA.debugLineNum = 393239;BA.debugLine="Try";
try {RDebugUtils.currentLine=393240;
 //BA.debugLineNum = 393240;BA.debugLine="cmp20.ConnectInsecure(btAdmin,PairedDevices.Get";
_cmp20.ConnectInsecure(processBA,_btadmin,BA.ObjectToString(_paireddevices.Get(_paireddevices.GetKeyAt((int) (0)))),(int) (1));
 } 
       catch (Exception e21) {
			processBA.setLastException(e21);RDebugUtils.currentLine=393242;
 //BA.debugLineNum = 393242;BA.debugLine="Msgbox(\"Connecting\",\"Printer Error\")";
anywheresoftware.b4a.keywords.Common.Msgbox("Connecting","Printer Error",mostCurrent.activityBA);
RDebugUtils.currentLine=393243;
 //BA.debugLineNum = 393243;BA.debugLine="printer.Close";
_printer.Close();
RDebugUtils.currentLine=393244;
 //BA.debugLineNum = 393244;BA.debugLine="cmp20.Disconnect";
_cmp20.Disconnect();
 };
 }else {
RDebugUtils.currentLine=393247;
 //BA.debugLineNum = 393247;BA.debugLine="L.Initialize";
_l.Initialize();
RDebugUtils.currentLine=393249;
 //BA.debugLineNum = 393249;BA.debugLine="For i = 0 To PairedDevices.Size - 1";
{
final int step27 = 1;
final int limit27 = (int) (_paireddevices.getSize()-1);
for (_i = (int) (0) ; (step27 > 0 && _i <= limit27) || (step27 < 0 && _i >= limit27); _i = ((int)(0 + _i + step27)) ) {
RDebugUtils.currentLine=393250;
 //BA.debugLineNum = 393250;BA.debugLine="L.Add(PairedDevices.GetKeyAt(i))";
_l.Add(_paireddevices.GetKeyAt(_i));
 }
};
RDebugUtils.currentLine=393253;
 //BA.debugLineNum = 393253;BA.debugLine="Res = InputList(L, \"Choose device\", -1)";
_res = anywheresoftware.b4a.keywords.Common.InputList(_l,"Choose device",(int) (-1),mostCurrent.activityBA);
RDebugUtils.currentLine=393254;
 //BA.debugLineNum = 393254;BA.debugLine="Log(Res)";
anywheresoftware.b4a.keywords.Common.Log(BA.NumberToString(_res));
RDebugUtils.currentLine=393255;
 //BA.debugLineNum = 393255;BA.debugLine="If Res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
RDebugUtils.currentLine=393256;
 //BA.debugLineNum = 393256;BA.debugLine="cmp20.Connect(PairedDevices.Get(L.Get(Res)))";
_cmp20.Connect(processBA,BA.ObjectToString(_paireddevices.Get(_l.Get(_res))));
 };
 };
RDebugUtils.currentLine=393259;
 //BA.debugLineNum = 393259;BA.debugLine="End Sub";
return "";
}
public static int[]  _getpixels(anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _bmp,int _offset,int _stride,int _x,int _y,int _width,int _height) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "getpixels"))
	return (int[]) Debug.delegate(mostCurrent.activityBA, "getpixels", new Object[] {_bmp,_offset,_stride,_x,_y,_width,_height});
anywheresoftware.b4j.object.JavaObject _jo = null;
int[] _pixels = null;
RDebugUtils.currentLine=589824;
 //BA.debugLineNum = 589824;BA.debugLine="Sub getPixels(bmp As Bitmap, offset As Int, stride";
RDebugUtils.currentLine=589825;
 //BA.debugLineNum = 589825;BA.debugLine="Dim jo = bmp As JavaObject";
_jo = new anywheresoftware.b4j.object.JavaObject();
_jo.setObject((java.lang.Object)(_bmp.getObject()));
RDebugUtils.currentLine=589826;
 //BA.debugLineNum = 589826;BA.debugLine="Dim pixels(width * height) As Int";
_pixels = new int[(int) (_width*_height)];
;
RDebugUtils.currentLine=589827;
 //BA.debugLineNum = 589827;BA.debugLine="jo.RunMethod(\"getPixels\", Array As Object(pixe";
_jo.RunMethod("getPixels",new Object[]{(Object)(_pixels),(Object)(_offset),(Object)(_width),(Object)(_x),(Object)(_y),(Object)(_width),(Object)(_height)});
RDebugUtils.currentLine=589828;
 //BA.debugLineNum = 589828;BA.debugLine="Return pixels";
if (true) return _pixels;
RDebugUtils.currentLine=589829;
 //BA.debugLineNum = 589829;BA.debugLine="End Sub";
return null;
}
public static String  _printer_connected(boolean _success) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "printer_connected"))
	return (String) Debug.delegate(mostCurrent.activityBA, "printer_connected", new Object[] {_success});
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Printer_Connected (Success As Boolean)";
RDebugUtils.currentLine=196609;
 //BA.debugLineNum = 196609;BA.debugLine="If Success Then";
if (_success) { 
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="Astream.Initialize(cmp20.InputStream,cmp20.Ou";
mostCurrent._astream.Initialize(processBA,_cmp20.getInputStream(),_cmp20.getOutputStream(),"printerAs");
RDebugUtils.currentLine=196611;
 //BA.debugLineNum = 196611;BA.debugLine="PrintReceipt";
_printreceipt();
 }else {
RDebugUtils.currentLine=196613;
 //BA.debugLineNum = 196613;BA.debugLine="If Msgbox2(\"\", \"Printer Error\",\"Reprint\",\"Cancel";
if (anywheresoftware.b4a.keywords.Common.Msgbox2("","Printer Error","Reprint","Cancel","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.Null),mostCurrent.activityBA)==anywheresoftware.b4a.keywords.Common.DialogResponse.POSITIVE) { 
RDebugUtils.currentLine=196614;
 //BA.debugLineNum = 196614;BA.debugLine="StartPrinter";
_startprinter();
 };
 };
RDebugUtils.currentLine=196617;
 //BA.debugLineNum = 196617;BA.debugLine="End Sub";
return "";
}
public static String  _printreceipt() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "printreceipt"))
	return (String) Debug.delegate(mostCurrent.activityBA, "printreceipt", null);
anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper _imagem = null;
int _x = 0;
int _y = 0;
anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper _out = null;
String _bits = "";
int[] _p = null;
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub PrintReceipt";
RDebugUtils.currentLine=458753;
 //BA.debugLineNum = 458753;BA.debugLine="DateTime.DateFormat = \"dd-MMM-yyyy\"";
anywheresoftware.b4a.keywords.Common.DateTime.setDateFormat("dd-MMM-yyyy");
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="DateTime.TimeFormat = \"HH:mm:ss\"";
anywheresoftware.b4a.keywords.Common.DateTime.setTimeFormat("HH:mm:ss");
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="Dim imagem As Bitmap, x As Int, y As Int";
_imagem = new anywheresoftware.b4a.objects.drawable.CanvasWrapper.BitmapWrapper();
_x = 0;
_y = 0;
RDebugUtils.currentLine=458757;
 //BA.debugLineNum = 458757;BA.debugLine="imagem = LoadBitmap(File.DirAssets, \"testebmp3.bm";
_imagem = anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"testebmp3.bmp");
RDebugUtils.currentLine=458759;
 //BA.debugLineNum = 458759;BA.debugLine="Dim out As OutputStream";
_out = new anywheresoftware.b4a.objects.streams.File.OutputStreamWrapper();
RDebugUtils.currentLine=458760;
 //BA.debugLineNum = 458760;BA.debugLine="out.InitializeToBytesArray(0)";
_out.InitializeToBytesArray((int) (0));
RDebugUtils.currentLine=458761;
 //BA.debugLineNum = 458761;BA.debugLine="out.WriteBytes(Array As Byte(0x1D),0,1)         '";
_out.WriteBytes(new byte[]{(byte) (0x1d)},(int) (0),(int) (1));
RDebugUtils.currentLine=458762;
 //BA.debugLineNum = 458762;BA.debugLine="out.WriteBytes(Array As Byte(0x2A),0,1)			'*";
_out.WriteBytes(new byte[]{(byte) (0x2a)},(int) (0),(int) (1));
RDebugUtils.currentLine=458763;
 //BA.debugLineNum = 458763;BA.debugLine="out.WriteBytes(Array As Byte(imagem.Width/8),0,1)";
_out.WriteBytes(new byte[]{(byte) (_imagem.getWidth()/(double)8)},(int) (0),(int) (1));
RDebugUtils.currentLine=458764;
 //BA.debugLineNum = 458764;BA.debugLine="out.WriteBytes(Array As Byte(imagem.Height),0,1)";
_out.WriteBytes(new byte[]{(byte) (_imagem.getHeight())},(int) (0),(int) (1));
RDebugUtils.currentLine=458766;
 //BA.debugLineNum = 458766;BA.debugLine="Dim  bits As String";
_bits = "";
RDebugUtils.currentLine=458767;
 //BA.debugLineNum = 458767;BA.debugLine="Dim p() As Int";
_p = new int[(int) (0)];
;
RDebugUtils.currentLine=458768;
 //BA.debugLineNum = 458768;BA.debugLine="p = getPixels(imagem, 0, imagem.Width, 0, 0, imag";
_p = _getpixels(_imagem,(int) (0),_imagem.getWidth(),(int) (0),(int) (0),_imagem.getWidth(),_imagem.getHeight());
RDebugUtils.currentLine=458769;
 //BA.debugLineNum = 458769;BA.debugLine="For x = 0 To p.Length-1";
{
final int step14 = 1;
final int limit14 = (int) (_p.length-1);
for (_x = (int) (0) ; (step14 > 0 && _x <= limit14) || (step14 < 0 && _x >= limit14); _x = ((int)(0 + _x + step14)) ) {
RDebugUtils.currentLine=458770;
 //BA.debugLineNum = 458770;BA.debugLine="If p(x) = -1 Then bits = bits & \"0\" Else bits =";
if (_p[_x]==-1) { 
_bits = _bits+"0";}
else {
_bits = _bits+"1";};
RDebugUtils.currentLine=458771;
 //BA.debugLineNum = 458771;BA.debugLine="If bits.Length = 8 Then";
if (_bits.length()==8) { 
RDebugUtils.currentLine=458772;
 //BA.debugLineNum = 458772;BA.debugLine="out.WriteBytes(Array As Byte(RetBytePOS(bits)),";
_out.WriteBytes(new byte[]{(byte) (_retbytepos(_bits))},(int) (0),(int) (1));
RDebugUtils.currentLine=458773;
 //BA.debugLineNum = 458773;BA.debugLine="bits = \"\"";
_bits = "";
 };
 }
};
RDebugUtils.currentLine=458776;
 //BA.debugLineNum = 458776;BA.debugLine="Astream.Write(Array As Byte(0x1D, 0x2A, 0, 0))";
mostCurrent._astream.Write(new byte[]{(byte) (0x1d),(byte) (0x2a),(byte) (0),(byte) (0)});
RDebugUtils.currentLine=458777;
 //BA.debugLineNum = 458777;BA.debugLine="Astream.Write(out.ToBytesArray)";
mostCurrent._astream.Write(_out.ToBytesArray());
RDebugUtils.currentLine=458778;
 //BA.debugLineNum = 458778;BA.debugLine="Astream.Write(Array As Byte(0x1D, Asc(\"/\"), 0))";
mostCurrent._astream.Write(new byte[]{(byte) (0x1d),(byte) (anywheresoftware.b4a.keywords.Common.Asc(BA.ObjectToChar("/"))),(byte) (0)});
RDebugUtils.currentLine=458779;
 //BA.debugLineNum = 458779;BA.debugLine="End Sub";
return "";
}
public static String  _printeras_error() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "printeras_error"))
	return (String) Debug.delegate(mostCurrent.activityBA, "printeras_error", null);
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub printerAs_Error";
RDebugUtils.currentLine=327681;
 //BA.debugLineNum = 327681;BA.debugLine="ToastMessageShow(LastException.Message, True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage(),anywheresoftware.b4a.keywords.Common.True);
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="Log(\"AStreams_Error\")";
anywheresoftware.b4a.keywords.Common.Log("AStreams_Error");
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="End Sub";
return "";
}
public static String  _printeras_newdata(byte[] _buffer) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "printeras_newdata"))
	return (String) Debug.delegate(mostCurrent.activityBA, "printeras_newdata", new Object[] {_buffer});
String _msg = "";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub printerAs_NewData (Buffer() As Byte)";
RDebugUtils.currentLine=262145;
 //BA.debugLineNum = 262145;BA.debugLine="Dim msg As String";
_msg = "";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="msg = BytesToString(Buffer, 0, Buffer.Length,";
_msg = anywheresoftware.b4a.keywords.Common.BytesToString(_buffer,(int) (0),_buffer.length,"UTF8");
RDebugUtils.currentLine=262147;
 //BA.debugLineNum = 262147;BA.debugLine="ToastMessageShow(msg, False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow(_msg,anywheresoftware.b4a.keywords.Common.False);
RDebugUtils.currentLine=262148;
 //BA.debugLineNum = 262148;BA.debugLine="Log(msg)";
anywheresoftware.b4a.keywords.Common.Log(_msg);
RDebugUtils.currentLine=262149;
 //BA.debugLineNum = 262149;BA.debugLine="End Sub";
return "";
}
public static int  _retbytepos(String _bitstr) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "retbytepos"))
	return (Integer) Debug.delegate(mostCurrent.activityBA, "retbytepos", new Object[] {_bitstr});
RDebugUtils.currentLine=524288;
 //BA.debugLineNum = 524288;BA.debugLine="Sub RetBytePOS(bitStr As String) As Int";
RDebugUtils.currentLine=524290;
 //BA.debugLineNum = 524290;BA.debugLine="Return (bitStr.SubString2(7,8)*1)+(bitStr.SubStri";
if (true) return (int) (((double)(Double.parseDouble(_bitstr.substring((int) (7),(int) (8))))*1)+((double)(Double.parseDouble(_bitstr.substring((int) (6),(int) (7))))*2)+((double)(Double.parseDouble(_bitstr.substring((int) (5),(int) (6))))*4)+((double)(Double.parseDouble(_bitstr.substring((int) (4),(int) (5))))*8)+((double)(Double.parseDouble(_bitstr.substring((int) (3),(int) (4))))*16)+((double)(Double.parseDouble(_bitstr.substring((int) (2),(int) (3))))*32)+((double)(Double.parseDouble(_bitstr.substring((int) (1),(int) (2))))*64)+((double)(Double.parseDouble(_bitstr.substring((int) (0),(int) (1))))*128));
RDebugUtils.currentLine=524291;
 //BA.debugLineNum = 524291;BA.debugLine="End Sub";
return 0;
}
}